#include <riter/RITERSphericalmirror.hh>

RITERSphericalmirror::RITERSphericalmirror(){
  r_mi[0]= 11400.0;
  r_mi[1]= 11400.0;
  if (!RICH_Vessel)   printf("RICH_Vessel not initialized\n");
  RICHVessel &rv = *RICH_Vessel;
  // calculate average CoC
  Vec3 up;
  Vec3 dn;
  int counter=0;

  for (int irow=0;irow<rv.spherical_mirror->numrow();irow++){
    for (int icol=0;icol<rv.spherical_mirror->numcol();icol++){
      Vec3 x0=rv.spherical_mirror->SingleMirror(irow,icol)->x0();
      Vec3 ez=rv.spherical_mirror->SingleMirror(irow,icol)->ez();
      if (irow>3) 
      up+= x0+r_mi[0]*ez;
      else
      dn+= x0+r_mi[1]*ez; 
      //      cout << counter << "mirror " <<  x0 << endl;
      sf_cen[counter++]=toRITERVec(x0);
    }
  } 
  rc_mu= 0.025*toRITERVec(up); // 40 mirrors
  rc_md= 0.025*toRITERVec(dn);  // 40 mirrors
  rcmi[0]= rc_mu;
  rcmi[1]= rc_md;  
  
  // corrections
  for (int i=0;i<80;i++) { 
         dx_sph[i]=0;
         dy_sph[i]=0;
  }
}

int  RITERSphericalmirror::Which_SFM( RITERVec  &r){
  // finds the ID of the spherical mirror where the point R is
  // R should be on spherical mirror
  // routine not optimised
  float tx=r.x()/r.z();
  float sf_tx= 0.266331613 ;  
  float sf_y=  1981.59998 ;
  if (r.z()<1000||fabs(tx)>sf_tx||fabs(r.y())>sf_y) return -1;
  int k0=0;
  if (r.y()>0) k0=40;
  int id=k0;
  float dmin= (r- sf_cen[id]).mag2();
  for (int k=k0+1;k<k0+40;k++) {
    float d= (r- sf_cen[k]).mag2();
    if (d<dmin) { 
      dmin=d;
      id=k;
    }
  }
  return id;
}

int RITERSphericalmirror::PrintSphericalmirror(){

  cout << "RITERSphericalmirror " << endl;
  cout << "rc_mi" << endl;
  for (int i=0;i<2;i++){ 
    cout << i <<  ":" << rcmi[i] << endl;
  }
  return RITER_OK;


}

