#ifndef _riter_angle_h_
#define _riter_angle_h_
 
#include <riter/RITER.hh>
#include <riter/RITERGeometry.hh>
#include <riter/RITERHits.hh>
#include <riter/RITERTracks.hh>
#include <riter/RITERUtils.hh>

extern RITERGeometry *RITER_Geometry ;
/// Calculation of the Cherenkov angles
class RITERAngle {
private:
  /// pointer to the geometry
  RITERGeometry *geo;
  /// number of hypothesis
  int nhip          ; 
public:
  /// calculates angles for a hit,track pair
  int   Calculate(RITERHits &f, RITERTracks  &t, float &th_cer, float &fi_cer, int &flag);
  /// calculates angles for a hit,track pair for 
  int   CalculateFull(RITERHits &f, RITERTracks  &t, float &th_cer, 
		      float &fi_cer,int &isfm, int &iplm, int &flag);
  ///
  int   cerenkov_kot( RITERVec &r0, RITERVec &dir, RITERVec &rh, 
			RITERVec rc,float r_mi, 
			RITERVec &dirf,RITERVec &dirch);
  ///
  int   resi_sin(float a,float b,float c,float &x,float &y);
  /// constructor of the class
  RITERAngle( int Nhip){ 
    if (!RITER_Geometry) RITER_Geometry=new  RITERGeometry();
    geo=RITER_Geometry; nhip=Nhip;  
  };
  /// destructor of the class
  ~RITERAngle(){};

};

#endif

