// -*- C++ -*-
// CLASSDOC OFF
// $Id: CLHEP.h,v 1.16 1999/04/20 07:28:05 evc Exp $
// ---------------------------------------------------------------------------
// CLASSDOC ON
//
// This file is a part of the CLHEP - a Class Library for High Energy Physics.
//
// This file contains definitions of some usefull utilities and macros.
//
#ifndef _RITER_CLHEP_H_
#define _RITER_CLHEP_H_

#include <stdlib.h>
#include <limits.h>
#include <math.h>

// #if defined(CLRITER_HEP_TARGET_H)
// #include CLRITER_HEP_TARGET_H
// #else
// #include "CLHEP/config/CLHEP-default.h"
// #endif

// CLASSDOC OFF
// **** You should probably not touch anything below this line: ****

typedef float float;
typedef int    RITERInt;
typedef float  RITERFloat;

#ifdef RITER_HEP_HAVE_BOOL
typedef bool RITERBoolean;
#else
typedef int RITERBoolean;
#ifndef false
#define false 0
#endif
#ifndef true
#define true 1
#endif
#endif /* RITER_HEP_HAVE_BOOL */

#ifdef RITER_HEP_SHORT_NAMES
typedef RITERBoolean Boolean;
#endif

#ifndef RITER_HEP_TEMPLATE_SPECIALIZATION
#ifdef  RITER_HEP_HAVE_EMPTY_TEMPLATE_PARAMETER_LIST
#define RITER_HEP_TEMPLATE_SPECIALIZATION template<>
#else
#define RITER_HEP_TEMPLATE_SPECIALIZATION
#endif
#endif

#ifndef RITER_HEP_BEGIN_NAMESPACE
#ifndef RITER_HEP_HAVE_NAMESPACE
#define RITER_HEP_BEGIN_NAMESPACE(A)
#else
#define RITER_HEP_BEGIN_NAMESPACE(A) namespace A {
#endif
#endif

#ifndef RITER_HEP_END_NAMESPACE
#ifndef RITER_HEP_HAVE_NAMESPACE
#define RITER_HEP_END_NAMESPACE(A)
#else
#define RITER_HEP_END_NAMESPACE(A) }
#endif
#endif

#ifndef RITER_HEP_USING_NAMESPACE
#ifndef RITER_HEP_HAVE_NAMESPACE
#define RITER_HEP_USING_NAMESPACE(A)
#else
#define RITER_HEP_USING_NAMESPACE(A) using namespace A;
#endif
#endif

#ifndef RITER_HEP_HAVE_EXPLICIT
#ifndef explicit
#define explicit
#endif
#endif

#ifndef RITER_HEP_HAVE_TYPENAME
#ifndef typename
#define typename
#endif
#endif

#ifndef RITER_HEP_USE_STD
#ifndef std
#define std
#endif
#endif

#ifndef M_PI_2
#define M_PI_2	1.57079632679489661923
#endif

#ifndef M_PI
#define M_PI	3.14159265358979323846
#endif

#ifndef M_2PI
#define M_2PI   6.28318530717958647692
#endif

#ifdef RITER_HEP_DEBUG_INLINE
#define RITER_HEP_NO_INLINE_IN_DECLARATION
#endif

#ifdef RITER_HEP_NO_INLINE_IN_DECLARATION
#define RITER_HEP_NO_INLINE_IN_TEMPLATE_DECLARATION
#endif

// Default to generate random matrix
//
#ifndef RITER_HEP_USE_RANDOM
#define RITER_HEP_USE_RANDOM
#endif

// Default to have assigment from three vector and rotation to matrix
//
#ifndef RITER_HEP_USE_VECTOR_MODULE
#define RITER_HEP_USE_VECTOR_MODULE
#endif

// GNU g++ compiler can optimize when returning an object.
// However g++ on HP cannot deal with this.
//
#undef RITER_HEP_GNU_OPTIMIZED_RETURN

// CLASSDOC ON
#endif /* _CLRITER_HEP_H_ */
