#ifndef _riter_hits_h_
#define _riter_hits_h_
/// desciption of a photon hit
class RITERHits { 
private:
public:
  /// photon hit virtual plane
  RITERVec rf;  
  /// angular error (sigma)
  float  sig;     
  /// photon weight (channel efficiency, occupancy);
  float  utez; 
  /// photon weight after iteration;   
  float  w;    
  /// PMT type
  int pmtype;
  /// constructor of the class 
  RITERHits(const RITERVec &r,float sigma=0.,float weight=1.,int pmttype=0){
    rf=r;
    sig=sigma;
    utez=weight;
    w=weight;
    pmtype=pmttype;
  };
  /// destructor
  ~RITERHits(){};
  /// weight of the hit
  inline float Weight(){return utez;}
  /// sigma of the hit
  inline RITERVec Sigma(){return sig;}
  /// Virtual position on the photon detector
  inline RITERVec Position(){return rf;}
  inline int Type(){return pmtype;};
}; 

#endif



