#ifndef _riter_iter_h_
#define _riter_iter_h_    

#include <riter/RITERTracks.hh>
#include <riter/RITERHits.hh>

inline void vzero(float  *x,int y) { for (int vz=0;vz<(y);vz++) *x++=0; return;} 

/// description of iterational table entry
class RITERTable {
 private:
 public:
  /// row
  int ir;
  /// track index
  int itra;
  /// hit index
  int ifot;
  /// channel index
  int icha;
  /// utez
  float utez;
  /// cherenkov angle
  float thc;
  /// polar angle
  float fic;
  /// weight of the entry
  float w;
  /// flag 0 = outside , 1 - signal window , -1 = bgr window
  int flag;
  /// constructor of the class
  RITERTable(int ir1,int itra1,int ifot1,int icha1,
	     float utez1,float th_cer,float fi_cer,float w1,int isinside) {  
    ir=ir1;
    itra=itra1;
    ifot=ifot1;
    icha=icha1;
    utez=utez1;
    thc=th_cer;
    fic=fi_cer;
    w=w1;
    flag=isinside;
  };
  // destructor of the class
  ~RITERTable(){};
  
  
};



/// Iterational picture analysis
class   RITERIter {
private:
  /// number of hypothesis
  int nhip;
  /// size of the bin
  float bin;
  /// size of table fotons 
  int nhits; 
  /// size of table tracks
  int ntra;  
  /// size of table rich
  int tablesize; 
  /// 
  vector  <RITERTracks> *Tracks;
  ///
  vector  <RITERHits>  *Fotons;
  ///
  vector  <RITERTable> rich;
  /// number of iterations already performed
  int niter;
public :
  /// initialization of the object
  RITERIter(int Nhip,RITERAngle *geo,
	    vector <RITERTracks> *RTracks,
	    vector <RITERHits>   *RHits );
  ///
  ~RITERIter(){
#ifdef RITER_DEBUG
    cout << "~RITERIter()\n";
#endif
}; 
  /// one iteration
  int Iterate(float &wdiff);
  /// Filling of the likelihoods
  int Likelihoods();
  /// Filling of the histos
  int HFill();
};
#endif












