#ifndef _riter_main_h_
#define _riter_main_h_

#include <riter/RITER.hh>

#include <riter/RITERPmt.hh>
#include <riter/RITERSupermodule.hh>
#include <riter/RITERPlanarmirror.hh>
#include <riter/RITERSphericalmirror.hh>
#include <riter/RITERGeometry.hh>
#include <riter/RITERAngle.hh>
#include <riter/RITERTracks.hh>
#include <riter/RITERHits.hh>
#include <riter/RITERFaktor.hh>
#include <riter/RITERIter.hh>

#ifdef RITER_DEBUG
#include <myhisto.hh>
#endif

class RITERMain {

protected:
  RITERGeometry *RITER_geo;
  RITERFaktor   *Faktor;  
  RITERAngle    *ThetaObj;
  vector <RITERTracks>  tracks;
  vector <RITERHits>    fotons;
   
  int nhip;                  // number of hypothesis
  int mode;                  
  int niter;                   // number od iterations

  float anzero_mul;            // NzeroNormalize
  float bgr_mul;               // BgrNormalize


  int   itip_lund(int ipart);
  int   read_ini( const char *);
  // ROOT histograming
  
#ifdef RITER_DEBUG 
  //  int bgr_calc_parameters(int nh,int ntra,richtab *rich );
#endif
  
  // ARTE interface
  RITERVec   toRICH( float x, float y, float z, RITERVec s);
  RITERVec   toRICH( RITERVec &r, RITERVec s);
  int test( );  
  // *********************** public members 
public:
  int    main();
  int AddPhoton(int sm ,int r,int c,int pos, int ch,int type);
    // add track 
  int AddTrack( RITERVec &dir,float err,RITERVec &point, float p);
  int AddTrack(float x, float y, float z, float tx, float ty, float p, 
	       float sx, float sy, float sz, float stx, float sty, float sp);
  
  inline int Reset(){tracks.clear(); fotons.clear(); return RITER_OK;}; 	    
  RITERMain();
  ~RITERMain(){
    delete Faktor;
  }

};
// ---------------------------------------------------------------------

float pois_log(float mean,float n);

#ifdef RITER_DEBUG
#include <myhisto.hh>
#else
//int myneve;
#endif



#endif 












